extern void k_clear_screen();
extern unsigned int k_printf(char* message, unsigned int line, char attribute);
extern void update_cursor(int row, int col);
extern unsigned char const k_getch();
extern void k_itoa(int value, char* valuestring);
extern void k_i2hex(unsigned int val, unsigned char* dest, int len);

int main()
{
	k_clear_screen();

	k_printf("   ************************************************", 0, 0xA);
	k_printf("   *                                              *", 1, 0xA);
	k_printf("   *          Welcome to HenkesSoft OS.           *", 2, 0xA);
	k_printf("   *                                              *", 3, 0xA);
	k_printf("   *        The C kernel has been loaded.         *", 4, 0xA);
	k_printf("   *                                              *", 5, 0xA);
	k_printf("   ************************************************", 6, 0xA);

	update_cursor(8, 0);

	unsigned char KeyGot=0;
	char bufferKEY[10];
	char bufferASCII[10];
	char bufferASCII_hex[10];

    int i;
	for(i=0;i<10000000;++i)
	{
	    int j;
        for(j=0;j<1000000;++j)/*do nothing*/;

        KeyGot = k_getch();   // port 0x60 -> scancode + shift key -> ASCII

        bufferKEY[0] = KeyGot;
        k_itoa(KeyGot,bufferASCII);
        k_i2hex(KeyGot,bufferASCII_hex,2);
        k_clear_screen();
        k_printf(bufferKEY,      0,0xA); // the ASCII character
        k_printf(bufferASCII,    1,0xA); // ASCII decimal
        k_printf(bufferASCII_hex,2,0xA); // ASCII hexadecimal
    };

	return 0;
};
